// Granat 

inherit "std/unit";

#include <properties.h>
#include <language.h>

create()
{
  if (!is_clone(this_object()) )  return;

  ::create();

  SetProp(P_SHORT, "Ein Granat");
  SetProp(P_LONG,  
    "Der Granat ist ein dunkelroter Edelstein.");
  SetProp(P_INFO, 
    "Manche Leute behaupten, ein Granat zieht Blitze an.\n");
  SetProp(P_NAME, ({"Granat", "Granate"}) );
  SetProp(P_GENDER, MALE);

  AddSingularId( ({"granat", "edelstein"}) );
  AddPluralId( ({"granate", "edelsteine"}) );
  AddId( "EDELSTEIN" );
  SetCoinsPerUnits(80,1);
  SetGramsPerUnits(5,1);

  SetProp(P_MATERIAL, MAT_MISC_JEWEL );
  SetProp(P_NOBUY, 1);

}
