//
// Standard Ork
//

#include <class.h> 
#include <properties.h>
#include <combat.h>
#include <moving.h>

#ifdef LOG
#undef LOG
#endif
#define LOG(x, text) write_file("/log/statistik/npcs/"+x, text)


inherit "/std/mnpc";
inherit "/std/player/moneyhandler";

string *_query_racestring()
{
    if(QueryProp(P_GENDER) == MALE)
    {
	return ({"Ork", "Orkes", "Ork", "Ork"});
    }
    else
    {
	return ({"Orkfrau", "Orkfraus", "Orkfrau", "Orkfrau"});
    }
}

void create_default_orc(int level)
{
    int	num;

    ::create_default_npc(level);
    SetProp(P_SPELLRATE, 5+level/2+random(level*2)); 
    if(QueryProp(P_SPELLRATE) >= 100)
    { SetProp(P_SPELLRATE, 80+random(16)); }

    if(level <= 35+random(6))
    { 
	SetProp(P_ATTRIBUTES, 
	    ([A_CON: level+(random(level)/6)-(random(level)/6)+5,
	      A_DEX: level+(random(level)/6)-(random(level)/6)+1,
	      A_INT: level+(random(level)/6)-(random(level)/6)-5,
	      A_STR: level+(random(level)/6)-(random(level)/6)+5
	    ]));
    }
    else
    {
	SetProp(P_ATTRIBUTES, ([A_CON: 35, A_DEX: 35, A_INT: 35, A_STR: 35]));
    }
    
    SetProp(P_BODY, (level<30?level*2:level)+random(15));
    SetProp(P_HANDS, 
	({" mit starken Faeusten",
	  30+(level/3)*10+random(10),
	  DT_BLUDGEON
	}));
    AddId("\nork");
    AddId("ork");
    AddId("FELL_WUSCHEL");
    SetProp(P_GENDER, MALE);
    SetProp(P_NAME, "Ork");
    SetProp(P_RACE, "Orks");
    SetProp(P_SHORT, "Ein Ork ohne alles");
    SetProp(P_LONG, "Ein Ork ohne Besonderheiten.\n");
    SetProp(P_AVERAGE_SIZE, 170);
    SetProp(P_SIZE, random(41)+150);
    SetProp(P_AVERAGE_WEIGHT, 70000);
    SetProp(P_WEIGHT, random(40000)+50000);
    SetProp(P_ATTRIBUTES_OFFSETS, 
	([A_DEX: 1, A_CON: 5, A_INT: -5, A_STR: 5]));
    SetProp(P_MAX_HANDS, 2);
    SetProp(P_AGGRESSIVE, 0);
    SetProp(P_RESISTANCE, 0);
    SetProp(P_VULNERABILITY, 0);
    SetProp(P_TEMPERATURE_RANGE, ([T_RANGE_MIN: 10, T_RANGE_MAX: 30]));  
    SetProp(P_NOMAGIC, 0);
    SetProp( P_DIE_MSG, " faellt mit einem Schrei zu Boden.\n" );
    AddInfo(DEFAULT_INFO,"mustert Dich veraechtlich.\n");
    SetProp(P_MSGIN,"trampelt herein");
    SetProp(P_MSGOUT,"trampelt#");
    SetProp(P_MMSGIN,"trampelt herein");
    SetProp(P_MMSGOUT,"verschwindet einfach");    
    SetProp(P_MAX_FOOD, 90);
    SetProp(P_MAX_ALCOHOL, 150);
    SetProp(P_MAX_DRINK, 100);
    
    SetProp(P_ALIGN, -500+random(500)+random(500));
    
    AddClass(CL_HUMANOID);
    AddClass(CL_ORC);        
}

void create_default_npc(int level)
{ 
create_default_orc(level); 
}

int create()
{
    if(!is_clone(this_object())) return 0;
    ::create();
}
