/* Moerder-Meldungen-Master 
 * Samtpfote@Tamedhon.at
 *
 * Damit die Leiche damit entlastet wird, und dass man da etwas flexibler
 * arbeitet.
 *
 * Der Master gibt *nur* einen string zurueck, sonst nix.
 *
 * Verschiedene Sachen, die dann da automatisch im String ersetzt werden:
 *
 *   %s        Spielername
 *   %E        einer der Erzmagier
 *   %G        Name der Gilde
 *   %W        aktuelle gezueckte Waffe
 *   
 */

#pragma strict
#pragma strong_types

#include <language.h>
#include <properties.h>

#define MOERDERMSGS "/p/daemon/save/killmsgs.txt"

string  *msgs;

int query_msg_count() { return sizeof(msgs); }

string generate_msg(object killer)
{
    string      msg, wn;
    int		i, is;
    object	*inv, *wp;

    if(!killer) return "";

    msg = msgs[random(sizeof(msgs))];

    /* Spielername */
    if(strstr(msg, "%s") != -1)
    { msg = regreplace(msg, "%s", killer->Name(WER, 1), 1); }
    
    /* Erzmagier */
    if(strstr(msg, "%E") != -1)
    {
        msg = regreplace(msg, "%E", 
                ({"Gralkor", "Serii", "Samtpfote", "Querolin"})[random(3)], 1);
    }
    
    /* Gilde des Spielers */
    if(strstr(msg, "%G") != -1)
    {
        msg = regreplace(msg, "%G", capitalize(killer->QueryProp(P_GUILD)), 1);
    }
    
    /* Waffe */
    if(strstr(msg, "%W") != -1)
    {
        wn=(killer->QueryProp(P_WEAPON)
            ?killer->QueryProp(P_WEAPON)->name(WEN)
            :"die Waffe");
	    
	if(wn == "die Waffe")
	{
	    wp=({});
	    is=sizeof(inv=all_inventory(killer));
	    if(is)
	    {
		for(i=0; i<is; i++)
		{
		    if(inv[i]->QueryProp(P_WEAPON)) { wp = wp + ({ inv[i] }); }
		}
		if(sizeof(wp))
		{
		    wn = wp[random(sizeof(wp))]->name(WEN);
		}
	    }
	}
	    
        msg = regreplace(msg, "%W", wn, 1);
    }
    
    return msg;
}

void reload_msgs()
{
    string	fdata;
    
    fdata = read_file(MOERDERMSGS);
    if(!fdata)
    {
	fdata = "Beim Lesen vom den Moerdermeldungen trat ein Problem auf!"; 
    }    
    
    msgs = efun::explode(fdata, "\n");
}

void create()
{
    msgs = ({});
    reload_msgs();
}
