/* NPC-Standard Blueprint 
 * Samtpfote@tamedhon
 *
 * einfach ein search'n'replace "rassename" -> "name" machen
 *
 */

#include <class.h> 
#include <properties.h>
#include <combat.h>
#include <moving.h>

#ifdef LOG
#undef LOG
#endif
#define LOG(x, text) write_file("/log/statistik/npcs/"+x, text)


inherit "/std/mnpc";
inherit "/std/player/moneyhandler";

string *_query_racestring()
{
    if(QueryProp(P_GENDER) == MALE)
    {
	return ({"Hobbit", "Hobbits", "Hobbit", "Hobbit"});
    }
    else
    {
	return ({"Hobbitfrau", "Hobbitfraus", "Hobbitfrau", "Hobbitfrau"});
    }
}

void create_default_hobbit(int level)
{
    int	num;

    ::create_default_npc(level);
    SetProp(P_SPELLRATE, 10+level/2+random(level*2)); 
    if(QueryProp(P_SPELLRATE) >= 100)
    { SetProp(P_SPELLRATE, 80+random(16)); }

    if(level <= 35+random(6))
    { 
	SetProp(P_ATTRIBUTES, 
	    ([A_CON: level+(random(level)/6)-(random(level)/6),
	      A_DEX: level+(random(level)/6)-(random(level)/6),
	      A_INT: level+(random(level)/6)-(random(level)/6),
	      A_STR: level+(random(level)/6)-(random(level)/6)
	    ]));
    }
    else
    {
	SetProp(P_ATTRIBUTES, ([A_CON: 35, A_DEX: 35, A_INT: 35, A_STR: 35]));
    }
    
    SetProp(P_BODY, (level<30?level*2:level)+random(15));
    SetProp(P_HANDS, 
	({" mit haarigen Haenden",
	  32+(level/3)*10+random(10),
	  DT_BLUDGEON
	}));
    AddId("\nhobbit");
    AddId("hobbit");
    
    SetProp(P_GENDER, MALE);
    SetProp(P_NAME, "Hobbit");
    SetProp(P_RACE, "Hobbit");
    SetProp(P_SHORT, "Ein unbeschriebener Hobbit");
    SetProp(P_LONG, "Das ist ein unbeschriebener Hobbit.\n");
    SetProp(P_AVERAGE_SIZE, 100);
    SetProp(P_SIZE, random(31)+85);
    SetProp(P_AVERAGE_WEIGHT, 60000);
    SetProp(P_WEIGHT, random(24000)+48000);
    SetProp(P_ATTRIBUTES_OFFSETS, 
	([A_DEX: 4, A_CON: 1, A_INT: 2, A_STR: -1]));
    SetProp(P_MAX_HANDS, 2);
    SetProp(P_AGGRESSIVE, 0);
    SetProp(P_DEFAULT_INFO,
	({"zuckt ahnungslos mit den Schultern.\n",
	  "schmaucht in sein Pfeifchen.\n",
	  "kitzelt Dich mit den haarigen Fuessen.\n",
	  "weiss leider auch nicht weiter.\n",
	  "hat so einfach nur Hunger und will gerade nichts davon wissen.\n",
	  "guggt ahnungslos drein.\n",
	  "erzaehlt Dir etwas ueber Hobis.\n",
	  "bohrt sich unwissend in die Nase.\n",
	  "hat davon keinen Schimmer.\n",
	  "interessiert sich nicht dafuer.\n",
	}));
    SetProp(P_LOG_INFO, 1);
    SetProp(P_RESISTANCE, 0);
    SetProp(P_VULNERABILITY, 0);
    SetProp(P_TEMPERATURE_RANGE, ([T_RANGE_MIN: 10, T_RANGE_MAX: 30]));  
    SetProp(P_NOMAGIC, random(10));
    SetProp(P_SPELLRATE, 0);
    SetProp(P_WIMPY, 0);
    SetProp(P_DIE_MSG, " kann gar nicht glauben dass Tod gekommen ist.\n");

    SetProp(P_MSGIN, "schlendert gemuetlich herein");
    SetProp(P_MSGOUT, "schlendert gemuetlich#");
    SetProp(P_MMSGIN, "schnippt mit den Fingern und ist weg");
    SetProp(P_MMSGOUT, "erscheint ganz unspektulaer");
    
    SetProp(P_MAX_FOOD, 130);
    SetProp(P_MAX_ALCOHOL, 100);
    SetProp(P_MAX_DRINK, 70);
    
    SetProp(P_ALIGN, 0);
    
    AddClass(CL_HUMANOID);
    AddClass(CL_HOBBIT);        
}

void create_default_npc(int level)
{ create_default_hobbit(level); }


int create()
{
    if(!is_clone(this_object())) return 0;
    ::create();
}
