/* Tamedhon MUDlib
 *
 * /secure/udp/who.c -- UDP who handling
 *
 * Revision 1.9  2001/03/04 20:37:00  Querolin
 * Design veraendert auf neues aussehen und paar bug-fixes
 *
 * Revision 1.8  2001/03/04 19:18:00  Querolin
 * Ab 10 Leuten nur mehr kurze Listenform. 
 * Zusaetzlich wird ab sofort die Statistik immer angezeigt
 *
 * Revision 1.7  2001/01/22 07:10:00  Querolin
 * PlayerCount eingebaut.  
 *
 * Revision 1.6
 * Mud-Adresse auf "mud.tamehon.at" geaendert....  Querolin
 *
 * $Date: 1998/01/03 14:00:09 $
 * $Revision: 1.5 $
 * $Log: who.c,v $
 * Revision 1.5  1998/01/03 14:00:09  Woody
 * "Test-MUD" rausgenommen
 *
 * Revision 1.4  1997/09/02 15:13:20  Woody
 * MUD-Adresse im remote 'wer' ausgeben
 *
 * Revision 1.3  1997/08/21 14:06:33  Woody
 * Kurzer Header bei -k, MaxUsers bei Merlin erfragen
 *
 * Revision 1.2  1997/08/20 22:59:30  Woody
 * Auswerten des DATA Fields (v.a. fuer short Listing etc.)
 *
 * Revision 1.1  1997/03/16 00:39:13  Woody
 * prepared for revision control
 *
 */

#include <udp.h>

#define MERLIN "/secure/merlin"
#define TD(x) if (find_player("debugger")) \\
                tell_object(find_player("debugger"),x)

#define DB(x)       if(find_player("samtpfote")) \
                tell_object(find_player("samtpfote"), \
                                break_string(x, 79, "{ "+file_name(this_object())+" } "));
  
int breite;    //  wird benoetigt, da bei kurzer und langer anzeige
               //  unterschiedliche breiten vorkommen... 


/*
int last;
int maxtoday, maxever;

void create()
{
  string tmp1, tmp2, dummy;

  if (time()-last<1800) return;
  last=time();
  tmp1=read_file("/etc/maxusers.ever",0,1);
  tmp2=read_file("/etc/maxusers",0,1);
  if (stringp(tmp1)&&strlen(tmp1)) (void)sscanf(tmp1,"%d %s",maxever,dummy);
  if (stringp(tmp2)&&strlen(tmp2)) (void)sscanf(tmp2,"%d %s",maxtoday,dummy);
}
*/

void udp_who(mapping data)
{
  int i,num;
  string *lines;
  string wholiste, header, args, str;
  mixed ans;

  //DB(sprintf("data=%O\n", data));
 
  // create();
  if (member(data,DATA)) args=data[DATA]; else args="";
  ans = "/std/player/base"->filter_who_options(args);
  breite=78;
  num=sizeof(users());
  if ( (num > 10) && (ans[0]==0) )
  {
   // Damit bei 'wer tamedhon' nicht die lange liste kommt wenn mehr als
   // 10 Spieler eingeloggt sind.    Querolin   04.03.2001
     ans[0]|=1;
  //   ans[1]|="short";    //braucht man des ueberhaupt?
     breite=75;
  }  

  lines = "/obj/werliste"->QueryWhoListe(0, ans[0], 0, ans[1]);

  wholiste = implode(lines,"\n");

  if (ans[0] & 1)
    lines=({
"      _ ",
"    _| |_                    _ _ ", 
"   (_   _)_ _ _ _ _  ___  __| | |__   __  _ _      mud.tamedhon.at 4711",
"     | |/ _` | '_` |/ -_)/ _  |  _ \\ /__\\| ` \\            212.33.48.141",
"     |_|\\__,_|_| |_|\\___|\\__,_|_| |_|\\__/|_||_|         www.tamedhon.at\n"
 }); 

  else
    lines=({
"     _                                                                  ",
sprintf("   _| |_                    _ _                  LPMud %:-11s (Amylaar)   ",__VERSION__),
"  (_   _)_ _ _ _ _  ___  __| | |__   __  _ _   Adresse: mud.tamedhon.at 4711",
"    | |/ _` | '_` |/ -_)/ _  |  _ \\ /__\\| ` \\        TD-Mudlib, beruhend auf",
"    |_|\\__,_|_| |_|\\___|\\__,_|_| |_|\\__/|_||_|             SL/MG/AL - Mudlib\n"
}); 

str=sprintf("Uptime: %s",uptime());
num=breite-strlen(str);
if (num>1)
{
  for(i=0;i<(num / 2);i++) {
    str=" "+str;
  }
}
lines+=({sprintf(str)});


  header=implode(lines,"\n");
  wholiste=header+"\n"+wholiste+"\n";
  num=sizeof(users());
  str=sprintf("Anwesende im Tamedhon: Aktuell %d, Max. heute gleichzeitig %d, "
              "Rekord %d\n",
              num, MERLIN->QueryMaxUsersToday(), MERLIN->QueryMaxUsers() );
  num=breite-strlen(str);
  if (num>1) 
  { 
    for(i=0;i<(num / 2);i++) {
      str=" "+str;
    }
  }
  wholiste+=sprintf("\n"+str);

  INETD->send_udp(data[NAME], ([
				REQUEST: REPLY,
				RECIPIENT: data[SENDER],
				ID: data[ID],
				DATA: wholiste
				]) );
}
